/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 */
package kelp.webapp.presentation;

// Xerces imports
import org.w3c.dom.html.HTMLElement;

// Servlet imports
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

// Standard imports
import java.io.IOException;

/**
 * <p>
 * This presentation object dynamically creates an HTML page
 * showing the greeting from the application configuration file.
 * </p>
 */
public class GreetingServlet extends HttpServlet {
    private final String GREETING = "Hello World!";

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response) throws ServletException,
                      IOException {
        GreetingHTML page = null;
        ServletOutputStream out;
        byte[] buffer;

        page = createPage();
        buffer = page.toDocument().getBytes();
        response.setContentType( "text/html" );
        response.setContentLength( buffer.length );
        out = response.getOutputStream();
        out.write(buffer);
        out.flush();
        response.flushBuffer();
    }

    public GreetingHTML createPage() {
        GreetingHTML page = null;
        HTMLElement  element = null;

        page = new GreetingHTML();
        element = page.getElementSpanGreeting();
        element.getFirstChild().setNodeValue(GREETING);
        return page;
    }

}
